function [f] = chem11(n)
%
%   Chemical equilibrium system
%
dim=length(n); 
p=40;
R=10;
K5=1.930e-1;
K6=2.597e-3;
K7=3.448e-3;
K8=1.799e-5;
K9=2.155e-4;
K10=3.846e-5;
for i=1:11:dim
    rap=p/n(i+10);
    f(i)=n(i)+n(i+3)-3.;
    f(i+1)=2*n(i)+n(i+1)+n(i+3)+n(i+6)+n(i+7)+n(i+8)+2*n(i+9)-R;
    f(i+2)=2*n(i+1)+2*n(i+4)+n(i+5)+n(i+6)-8;
    f(i+3)=2*n(i+2)+n(i+8)-4*R;
    f(i+4)=K5*n(i+1)*n(i+3)-n(i)*n(i+4);
    f(i+5)=K6*K6*n(i+1)*n(i+3)-n(i)*n(i+5)*n(i+5)*rap;
    f(i+6)=K7*K7*n(i)*n(i+1)-n(i+3)*n(i+6)*n(i+6)*rap;
    f(i+7)=K8*n(i)-n(i+3)*n(i+7)*rap;
    f(i+8)=K9*K9*n(i)*n(i)*n(i+2)-n(i+3)*n(i+3)*n(i+8)*n(i+8)*rap;
    f(i+9)=K10*n(i)*n(i)-n(i+3)*n(i+3)*n(i+9)*rap;
    f(i+10)=n(i+10)-sum(n(i:i+9));
end
f=f';