function [fx] = poisson(x)

n=length(x);
nd=sqrt(n);
h=1/(nd+1); h2=h^2;
fx=ones(n,1);   

fx(1)=x(2)+x(nd+1)+1.d0+1.d0-4.d0*x(1)+ h2*x(1)^3/(1.d0+h^2+h^2);
fx(n)=x(n-1)+x(n-nd)+2.d0-exp(h*nd)+2.d0-exp(h*nd)-4.d0*x(n)+h^2*x(n)^3/(1.d0+(h*nd)^2+(h*nd)^2);

k=(nd-1)*nd+1;
fx(k)=x(k+1)+x((nd-2)*nd+1)+1.d0+2.d0-exp(h)-4.d0*x(k)+	 h^2*x(k)^3/(1.d0+h^2+(h*nd)^2);

k=nd;
fx(k)=x(k-1)+x(nd+nd)+2.d0-exp(h)+1.d0-4.d0*x(k)+h^2*x(k)^3/(1.d0+h^2+(h)^2);

j=2:(nd-1);
k=nd*(j-1)+1;
fx(k)=x(k+1)+x(nd*j+1)+x(nd*(j-2)+1)+1-4*x(k)+h^2*x(k).^3./(1.d0+h^2+(h*j').^2);

j=2:nd-1;
k=(j-1)*nd+nd;
fx(k)=x(k-1)+x(j*nd+nd)+x((j-2)*nd+nd)+2-exp(h*j')-4*x(k)+h^2*x(k).^3./(1.d0+(h*nd)^2+(h*j)'.^2);

i=2:nd-1;
k=i;
fx(k)=x(k+1)+x(k-1)+x(nd+i)+1-4*x(k)+ h^2*x(k).^3./(1+h^2+(h*i').^2);

i=2:nd-1;
k=(nd-1)*nd+i;
fx(k)=x(k+1)+x(k-1)+x((nd-2)*nd+i)+2-exp(h*i')-4*x(k)+ h^2*x(k).^3./(1.d0+(h*nd)^2+(h*i').^2);

for j=2:nd-1
    i=2:nd-1;
    k=(j-1)*nd+i;
    fx(k)=x(k+1)+x(k-1)+x(j*nd+i)+x((j-2)*nd+i)-4*x(k)+ h^2*x(k).^3./(1.d0+(h*i').^2+(h*j)^2);
end
fx = sparse(fx);