%
% test secant method
%
function test
  
  % problem parameter
  x0   = 3 ;
  x1   = 2.5 ;
  epsi = 1E-15 ;
  
  % call the solver
  X = secant(@fun,x0,x1,epsi) ;

  % exact solution
  xe = 3^(1/3);
  
  % error vector
  ERR = abs(X-xe) ;

  % estimate order of convergence
  ORDER = log(ERR(3:end)./ERR(2:end-1)) ...
       ./ log(ERR(2:end-1)./ERR(1:end-2)) ;

  % print the order estimeted
  disp(ORDER) ;
  
  % fancy plot of the iterations
  secantPlotIteration(@fun,X,xe) ;

end

function res = fun(x)
  %res = x.*exp(x)./(1+x.^2) ;
  %res = x.^2-3 ;
  %res = (x-3).^3+(x-3)*0.1 ;
  %res = exp(x)-x ;
  res = x.^3 - 3 ;
end