addpath('parseArgs') ;
addpath('functions') ;
addpath('linesearch') ;
addpath('minimizer') ;

%fun = @Rosenbrock ;
%fun = @Easom ;
%fun = @PowellBadlyScaled ;
%fun = @Quadratic ;
%fun = @Han ;
%fun = @Wood ;

%fun = @BrownBadlyScaled ;
fun = @PowellBadlyScaled ;

need_wrapper = false ;
if need_wrapper
  FunWrapper( 'set', fun ) ;
  fw = @FunWrapper ;
else
  fw = fun ;
end

[X,F,NG] = LevenbergMarquardt( fw, feval(fw,'init'), ...
                               'tol',        1E-6, ...
                               'maxiter',    1000 ) ;

xx = [-2:0.1:2] ;
yy = [-2:0.1:2] ;
nx = length(xx) ;
ny = length(yy) ;
zz = zeros( nx, ny ) ;
for i=1:nx
  for j=1:ny
    %zz(j,i) = log(1+feval( fun, 'f', [xx(i);yy(j)] )) ;
    zz(j,i) = feval( fun, 'f', [xx(i);yy(j);0;0] ) ;
  end
end
subplot(2,1,1)
contourf( xx, yy, zz ) ;
hold on
plot( X(1,:), X(2,:), '-or', 'Linewidth', 1 );
hold off

subplot(2,1,2)
semilogy( F-min(F), '-or', 'Linewidth', 1 );

X(:,end)
F(end)
NG(end)
